; GetParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables. 

!ifdef UseEscapedGetParametersFunc
  !echo "Precompile Trunk: UseEscapedGetParametersFunc (Ln:${__LINE__})"

  ;=== Get Paraemeters Function ; rewritten by hobbyscripter
  Function "GetParameters"
    ; -----
    ; Function Init
    ; -----
    ; Backup the VARIABLE
    Push $R0 ; Stack: [...] << $R0
    Push $R1 ; Stack: [...] << $R0 << $R1
    Push $R2 ; Stack: [...] << $R0 << $R1 << $R2
    Push $R3 ; Stack: [...] << $R0 << $R1 << $R2 << $R3
    Push $R4 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4
    Push $R5 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4 << $R5
    ; Give the VARIABLE a clear name
    !define CopyOfCommandLine $R0
    !define StringLength $R1
    !define SearchTarget $R2
    !define CurrentChar $R3
    !define Position $R4
    !define Output $R5
    ; Clear The Errors
    ClearErrors

    ; -----
    ; Check the Command Line Format
    ; -----
    StrCpy ${CurrentChar} $CMDLINE 1
    ; If_FirstCharEqualQuote:
    StrCmp ${CurrentChar} '"' 0 UsingSpace ; Check if using format like `"executable" parameters` or `executable parameters`
      StrCpy ${SearchTarget} '"' ; Make SearchTarget
        ${DualCharToSingleChar} ${CopyOfCommandLine} $CMDLINE ; Make a copy for CMDLINE
        Goto EndIf_FirstCharEqualQuote
    UsingSpace:
      StrCpy ${SearchTarget} ' ' ; Make SearchTarget
      StrCpy ${CopyOfCommandLine} $CMDLINE ; Make a copy for CMDLINE
    EndIf_FirstCharEqualQuote:

    ; -----
    ; Get The Length Of $CMDLINE
    ; -----
    StrLen ${StringLength} ${CopyOfCommandLine}

    ; -----
    ; Search The Target
    ; -----
    StrCpy ${Position} 1 ; Start from 0 but '"' is a character as well, so +1
    While_FoundSearchTarget:
      ; If_PositionLessLengthOfCommandLine:
      IntCmp ${Position} ${StringLength} Wend_FoundSearchTarget 0 Wend_FoundSearchTarget
      StrCpy ${CurrentChar} ${CopyOfCommandLine} 1 ${Position}
      StrCmp ${CurrentChar} ${SearchTarget} Wend_FoundSearchTarget
      IntOp ${Position} ${Position} + 1
      Goto While_FoundSearchTarget
      ; Else_PositionLessLengthOfCommandLine:
        ; Goto Wend_FoundSearchTarget
      ; EndIf_PositionLessLengthOfCommandLine:
    Wend_FoundSearchTarget:
    IntOp ${Position} ${Position} + 1 ; Point to the next char of SearchTarget

    ; -----
    ; Copy Output Words
    ; -----
    StrCpy ${Output} ${CopyOfCommandLine} "" ${Position}

    ; -----
    ; Unescape the result
    ; -----
    ; If_SearchTargetEqualQuote
    StrCmp ${SearchTarget} '"' 0 EndIf_SearchTargetEqualQuote
      ; If_SkipUseFirefoxFormatPathEqualFalse:
      ${SingleCharToDualChar} ${Output} ${Output}
      ; EndIf_SkipUseFirefoxFormatPathEqualFalse
    EndIf_SearchTargetEqualQuote:

    ; -----
    ; Clear The Space
    ; -----
    ; Front Space
    IntOp ${Position} 0 + 0 ; New Position
    StrLen ${StringLength} ${Output} ; New Length for Output
    While_NoMoreFrontSpace:
      ; If_PositionLessLengthOfOutput:
      IntCmp ${Position} ${StringLength} Wend_NoMoreFrontSpace 0 Wend_NoMoreFrontSpace
        StrCpy ${CurrentChar} ${Output} 1 ${Position}
        ; If_CurrentCharEqualSpace:
        StrCmp ${CurrentChar} ' ' 0 Wend_NoMoreFrontSpace
          IntOp ${Position} ${Position} + 1
          Goto While_NoMoreFrontSpace
        ; EndIf_CurrentCharEqualSpace:
      ; EndIf_PositionLessLengthOfOutput:
    Wend_NoMoreFrontSpace:
    StrCpy ${Output} ${Output} "" ${Position} ; Cut the String to delete the space
    ; End Space
    StrLen ${StringLength} ${Output} ; New Position
    IntOp ${Position} ${StringLength} - 1 ; New Length for Output
    While_NoMoreEndSpace:
      ; If_PositionLessLengthOfOutput:
      IntCmp ${Position} 0 0 Wend_NoMoreEndSpace 0
        StrCpy ${CurrentChar} ${Output} 1 ${Position}
        ; If_CurrentCharEqualSpace:
        StrCmp ${CurrentChar} ' ' 0 Wend_NoMoreEndSpace
          IntOp ${Position} ${Position} - 1
          Goto While_NoMoreEndSpace
        ; EndIf_CurrentCharEqualSpace:
      ; EndIf_PositionLessLengthOfOutput:
    Wend_NoMoreEndSpace:
    IntOp ${Position} ${Position} + 1 ; Because MaxLength Of StrCpy is start with 1
    StrCpy ${Output} ${Output} ${Position} ; Cut the String to delete the space

    ; -----
    ; Function Ending
    ; -----
    ; Undefine the Name
    !undef CopyOfCommandLine
    !undef StringLength
    !undef SearchTarget
    !undef CurrentChar
    !undef Position
    !undef Output
    ; Recover the VARIABLES and return the value
    StrCpy $R0 $R5 ; Exchange
    Pop $R5 ; Stack: [...] << $R0 << $R1 << $R2 << $R3 << $R4
    Pop $R4 ; Stack: [...] << $R0 << $R1 << $R2 << $R3
    Pop $R3 ; Stack: [...] << $R0 << $R1 << $R2
    Pop $R2 ; Stack: [...] << $R0 << $R1
    Pop $R1 ; Stack: [...] << $R0
    Exch $R0 ; Stack: [...] << [Output]
  FunctionEnd
!else
  !echo "Precompile Trunk: UseOriginalGetParametersFunc (Ln:${__LINE__})"

  ;=== Get Paraemeters Function
  Function GetParameters
    Push $R0
    Push $R1
    Push $R2
    Push $R3

    StrCpy $R2 1
    StrLen $R3 $CMDLINE

    ;Check for quote or space
    StrCpy $R0 $CMDLINE $R2
    StrCmp $R0 '"' 0 +3
      StrCpy $R1 '"'
      Goto loop
    StrCpy $R1 " "

    loop:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 $R1 get
      StrCmp $R2 $R3 get
      Goto loop

    get:
      IntOp $R2 $R2 + 1
      StrCpy $R0 $CMDLINE 1 $R2
      StrCmp $R0 " " get
      StrCpy $R0 $CMDLINE "" $R2

    Pop $R3
    Pop $R2
    Pop $R1
    Exch $R0
  FunctionEnd
!endif